#include "mv.hh"

// initialize structure to a vector of size 0
Vec::Vec() {
  cout << "Call constructor for Vec\n" ;
  _size  = 0 ;
  values = nullptr ;
}

Vec::Vec( int _sz ) : _size(_sz) {
  cout << "Call constructor for Vec with size = " << _size << "\n" ;
  values = new double[_size] ; // allocate memory for the vector
}

Vec::~Vec( ) {
  cout << "Call detructor for Vec\n" ;
  // check if alreay de-allocated
  if ( values != nullptr ) delete [] values ;
  _size = 0 ;
}

// alocate a vector to teh size: size
void
Vec::Allocate( int size ) {
  _size = size ;
  // check if alreay allocated
  if ( values != nullptr ) delete [] values ;
  values = new double[_size] ;
}

void
Vec::Fill( double val ) {
  for ( int i = 0 ; i < _size ; ++i )
    values[i] = val ;
}
